import { Optional } from '../util';
export interface IGameCode {
    code: string;
    sourceOffset: number;
}
export interface IGameCodeWithSource {
    sourceString: string;
}
export declare function getLineAndColumn(str: string, offset: number): {
    lineNum: number;
    colNum: number;
    line: string;
    prevLine: string | null;
    nextLine: string | null;
};
export declare class BaseForLines {
    readonly __source: IGameCode;
    __coverageCount: Optional<number>;
    constructor(source: IGameCode);
    __getSourceLineAndColumn(): {
        lineNum: number;
        colNum: number;
        line: string;
        prevLine: string | null;
        nextLine: string | null;
    };
    toString(): string;
    toSourceString(): string;
    __getLineAndColumnRange(): {
        start: {
            line: number;
            col: number;
        };
        end: {
            line: number;
            col: number;
        };
    };
    __incrementCoverage(): void;
}
