import { Optional } from '../util';
import { IColor } from './colors';
export declare class Dimension {
    readonly width: number;
    readonly height: number;
    constructor(width: number, height: number);
}
export declare class GameMetadata {
    author: Optional<string>;
    homepage: Optional<string>;
    youtube: Optional<string>;
    zoomscreen: Optional<Dimension>;
    flickscreen: Optional<Dimension>;
    colorPalette: Optional<string>;
    backgroundColor: Optional<IColor>;
    textColor: Optional<IColor>;
    realtimeInterval: Optional<number>;
    keyRepeatInterval: Optional<number>;
    againInterval: Optional<number>;
    noAction: boolean;
    noUndo: boolean;
    runRulesOnLevelStart: Optional<string>;
    noRepeatAction: boolean;
    scanline: boolean;
    throttleMovement: boolean;
    noRestart: boolean;
    requirePlayerMovement: boolean;
    verboseLogging: boolean;
    constructor();
    _setValue(key: string, value: boolean | number | string | Dimension | IColor): void;
}
