import { GameData } from '../models/game';
import { RULE_DIRECTION_WITH_RELATIVE } from '../util';
import * as ast from './astTypes';
export declare class AstBuilder {
    private readonly code;
    private readonly tileCache;
    private readonly soundCache;
    constructor(code: string);
    build(root: ast.IASTGame<RULE_DIRECTION_WITH_RELATIVE, string, string, number | '.'>): GameData;
    private buildSprite;
    private buildColor;
    private buildLegendItem;
    private buildCollisionLayer;
    private buildSound;
    private buildCommand;
    private buildWinConditon;
    private buildLevel;
    private buildSimpleRules;
    private simplifyRule;
    private rule_toSimple;
    private rule_convertToMultiple;
    private rule_clone;
    private rule_getDirectionModifiers;
    private rule_hasModifier;
    private rule_getAllBracketNeighbors;
    private bracket_clone;
    private neighbor_clone;
    private tile_clone;
    private bracket_toSimple;
    private neighbor_toSimple;
    private tile_toSimple;
    private toSource;
    private cacheHas;
    private cacheAdd;
    private cacheGet;
    private soundCacheAdd;
    private soundCacheGet;
    private soundCacheHas;
}
