import { IGameCode } from '../models/BaseForLines';
import { GameLegendTileSimple, GameSprite, IGameTile } from '../models/tile';
import { SfxSoundItem } from './astTypes';
export declare class LookupHelper {
    _allSoundEffects: Map<string, SfxSoundItem<IGameTile>>;
    _allObjects: Map<string, GameSprite>;
    _allLegendTiles: Map<string, IGameTile>;
    _allLevelChars: Map<string, IGameTile>;
    constructor();
    _addToHelper<A>(map: Map<string, A>, key: string, value: A): void;
    addSoundEffect(key: string, soundEffect: SfxSoundItem<IGameTile>): void;
    addToAllObjects(gameObject: GameSprite): void;
    addToAllLegendTiles(legendTile: GameLegendTileSimple): void;
    addObjectToAllLevelChars(levelChar: string, gameObject: GameSprite): void;
    addLegendToAllLevelChars(legendTile: GameLegendTileSimple): void;
    lookupObjectOrLegendTile(source: IGameCode, key: string): IGameTile;
    lookupByLevelChar(key: string): IGameTile;
    lookupSoundEffect(key: string): SfxSoundItem<IGameTile> | undefined;
}
