import { GameData } from './models/game';
interface ICoverageLocation {
    line: number;
    col: number;
}
interface ICoverageLocationRange {
    start: ICoverageLocation;
    end: ICoverageLocation;
}
interface ICoverageFunction {
    name: string;
    decl: ICoverageLocationRange;
    loc: ICoverageLocationRange;
    line: number;
}
interface ICoverageCount {
    [id: string]: number;
}
interface ICoverageStatements {
    [id: string]: ICoverageLocationRange;
}
interface ICoverageFunctions {
    [id: string]: ICoverageFunction;
}
interface ICoverageEntry {
    path: string;
    s: ICoverageCount;
    f: ICoverageCount;
    statementMap: ICoverageStatements;
    fnMap: ICoverageFunctions;
    branchMap: object;
    b: object;
}
export declare function saveCoverageFile(data: GameData, absPath: string, pathRelative: (p: string) => string): {
    [path: string]: ICoverageEntry;
};
export {};
